diff -ruN ../nakedmudv2.4/src/scripts/pyevent.c src/scripts/pyevent.c
--- ../nakedmudv2.4/src/scripts/pyevent.c	Wed Dec 31 17:00:00 1969
+++ src/scripts/pyevent.c	Sat Jun 18 14:46:43 2005
@@ -0,0 +1,163 @@
+//*****************************************************************************
+//
+// pyevent.c
+//
+// pyevent gives Python access to NakedMud's event handler in a limited form.
+// Unlike normal events which can have owners of any sort, python events can
+// only have owners that are characters, objects, or rooms. Other than that,
+// python events are identical to normal events.
+//
+//*****************************************************************************
+
+#include <Python.h>
+
+#include "../mud.h"
+#include "../event.h"
+
+#include "pychar.h"
+#include "pyroom.h"
+#include "pyobj.h"
+
+
+
+//*****************************************************************************
+// local functions
+//*****************************************************************************
+void PyEvent_on_complete(void *owner, PyObject *tuple, const char *arg) {
+  PyObject *PyOwner = NULL;
+  PyObject   *efunc = NULL;
+  PyObject   *edata = NULL;
+
+  // make sure we parse everything before we call the function
+  if(PyArg_ParseTuple(tuple, "OOO", &PyOwner, &efunc, &edata)) {
+    PyObject *ret = PyObject_CallFunction(efunc, "OOs", PyOwner, edata, arg);
+    Py_XDECREF(ret);
+  }
+
+  // decrease the reference on our function and data
+  //  Py_DECREF(tuple);
+}
+
+
+
+//*****************************************************************************
+// implementation of our methods and method table
+//*****************************************************************************
+
+//
+// no point in reinventing the wheel; start_event and start_update both
+// need to be handled exactly the same, so here's a function to do just that
+PyObject *PyEvent_start(PyObject *self, PyObject *args, void *func) {
+  void (* start_func)(void *, int, void *, void *, void *, const char *) = func;
+  PyObject *PyOwner = NULL;    // the python representation of our owner
+  PyObject   *efunc = NULL;    // the event function
+  PyObject   *edata = Py_None; // the event data
+  char         *arg = NULL;    // the arg we will be supplying to the function
+  double      delay = 0;       // how long the event delay is (in seconds)
+  void       *owner = NULL;    // actual owner supplied to the event handler
+
+  // try to parse all of our values
+  if(!PyArg_ParseTuple(args, "OdO|Os", &PyOwner, &delay, &efunc, &edata, &arg)){
+    PyErr_Format(PyExc_TypeError, 
+		 "Invalid arguments provided to event handler");
+    return NULL;
+  }
+
+  // make sure our event is a function
+  if(!PyFunction_Check(efunc)) {
+    PyErr_Format(PyExc_TypeError,
+		 "The event handler supplied must be a python function");
+    return NULL;
+  }
+
+  // figure out what type of data our owner is
+  if(PyOwner == Py_None)
+    owner = Py_None;
+  else if(PyChar_Check(PyOwner))
+    owner = PyChar_AsChar(PyOwner);
+  else if(PyRoom_Check(PyOwner))
+    owner = PyRoom_AsRoom(PyOwner);
+  else if(PyObj_Check(PyOwner))
+    owner = PyObj_AsObj(PyOwner);
+  // invalid type
+  else {
+    PyErr_Format(PyExc_TypeError,
+		 "An event owner must be a room, char, obj, or none");
+    return NULL;
+  }
+
+  // make sure the owner exists
+  if(owner == NULL) {
+    PyErr_Format(PyExc_StandardError, "Owner supplied does not exist in game");
+    return NULL;
+  }
+  
+  // now, queue up the action
+  start_func(owner, (int)(delay SECONDS), PyEvent_on_complete, NULL, 
+	     Py_BuildValue("OOO", PyOwner, efunc, edata), arg);
+
+  // everything seems ok. exit normally
+  return Py_BuildValue("i", 1);
+}
+
+
+//
+// start a new event
+PyObject *PyEvent_start_event(PyObject *self, PyObject *args) {
+  return PyEvent_start(self, args, start_event);
+}
+
+
+//
+// start a new update (event that re-queues itself after completion)
+PyObject *PyEvent_start_update(PyObject *self, PyObject *args) {
+  return PyEvent_start(self, args, start_update);
+}
+
+//
+// interrupt an event involving the given room, object, or mobile
+PyObject *PyEvent_interrupt_event(PyObject *self, PyObject *args) {
+  PyObject *PyOwner = NULL; // the python representation of our owner
+
+  // parse our owner
+  if(!PyArg_ParseTuple(args, "O", &PyOwner)) {
+    PyErr_Format(PyExc_TypeError,
+		 "A target must be specified for interrupting events.");
+    return NULL;
+  }
+
+  // check the possibilities
+  if(PyOwner == Py_None)
+    interrupt_events_involving(NULL);
+  else if(PyChar_Check(PyOwner))
+    interrupt_events_involving(PyChar_AsChar(PyOwner));
+  else if(PyRoom_Check(PyOwner))
+    interrupt_events_involving(PyRoom_AsRoom(PyOwner));
+  else if(PyObj_Check(PyOwner))
+    interrupt_events_involving(PyObj_AsObj(PyOwner));
+
+  // everything ok
+  return Py_BuildValue("i", 1);
+}
+
+
+//
+// the all methods that are contained within the event module
+PyMethodDef event_module_methods[] = {
+  {"start_event",  PyEvent_start_event, METH_VARARGS,
+   "Add a new python event to the event queue."},
+  {"start_update",  PyEvent_start_update, METH_VARARGS,
+   "Add a new python update to the event queue. Like an event, but readds "
+   "itself to the event queue after completion."},
+  {"interrupt_events_involving",  PyEvent_interrupt_event, METH_VARARGS,
+   "Interrupt all of the events involving the given object, room, or char."},
+};
+
+
+
+//*****************************************************************************
+// implementation of pyevent.h
+//*****************************************************************************
+PyMODINIT_FUNC init_PyEvent(void) {
+  Py_InitModule3("event", event_module_methods, "The mud's event handler.");
+}
diff -ruN ../nakedmudv2.4/src/scripts/pyevent.h src/scripts/pyevent.h
--- ../nakedmudv2.4/src/scripts/pyevent.h	Wed Dec 31 17:00:00 1969
+++ src/scripts/pyevent.h	Sat Jun 18 14:46:43 2005
@@ -0,0 +1,17 @@
+#ifndef PYEVENT_H
+#define PYEVENT_H
+//*****************************************************************************
+//
+// pyevent.c
+//
+// pyevent gives Python access to NakedMud's event handler in a limited form.
+// Unlike normal events which can have owners of any sort, python events can
+// only have owners that are characters, objects, or rooms. Other than that,
+// python events are identical to normal events.
+//
+//*****************************************************************************
+
+// initialize the pyevent system for use
+PyMODINIT_FUNC init_PyEvent(void);
+
+#endif // PYEVENT_H
diff -ruN ../nakedmudv2.4/src/scripts/pymud.c src/scripts/pymud.c
--- ../nakedmudv2.4/src/scripts/pymud.c	Sat Jun  4 23:40:29 2005
+++ src/scripts/pymud.c	Sat Jun 18 15:30:35 2005
@@ -17,6 +17,7 @@
 #include "../mud.h"
 #include "../utils.h"
 #include "../character.h"
+#include "../inform.h"
 
 #include "script.h"
 #include "pyroom.h"
@@ -75,8 +76,7 @@
 //   erase_global(key)
 //
 //*****************************************************************************
-static PyObject *
-mud_get_global(PyObject *self, PyObject *args) {
+PyObject *mud_get_global(PyObject *self, PyObject *args) {
   PyObject *key = NULL;
 
   // get the key
@@ -94,8 +94,7 @@
   return val;
 }
 
-static PyObject *
-mud_set_global(PyObject *self, PyObject *args) {
+PyObject *mud_set_global(PyObject *self, PyObject *args) {
   PyObject *key = NULL, *val = NULL;
 
   if (!PyArg_ParseTuple(args, "OO", &key, &val)) {
@@ -109,8 +108,7 @@
 }
 
 
-static PyObject *
-mud_erase_global(PyObject *self, PyObject *args) {
+PyObject *mud_erase_global(PyObject *self, PyObject *args) {
   PyObject *key = NULL;
 
   if (!PyArg_ParseTuple(args, "O", &key)) {
@@ -130,8 +128,7 @@
 // and maximum position in the form of strings, a level, and boolean values
 // for whether the command can be performed by mobiles, and whether it 
 // interrupts actions.
-static PyObject *
-mud_add_cmd(PyObject *self, PyObject *args) {
+PyObject *mud_add_cmd(PyObject *self, PyObject *args) {
   PyObject *func = NULL;
   char *name  = NULL, *sort_by = NULL, *min_pos = NULL, *max_pos = NULL,
        *group = NULL;
@@ -167,8 +164,7 @@
 
 //
 // format a string to be into a typical description style
-static PyObject *
-mud_format_string(PyObject *self, PyObject *args) {
+PyObject *mud_format_string(PyObject *self, PyObject *args) {
   char *string = NULL;
 
   // parse all of the values
@@ -178,12 +174,120 @@
     return NULL;
   }
 
+  // dup the string so we can work with it and not intrude on the PyString data
+  string = strdupsafe(string);
   format_string(&string, 80, MAX_BUFFER, TRUE);
   PyObject *ret = Py_BuildValue("s", string);
   free(string);
   return ret;
 }
 
+//
+// execute message() from inform.h
+PyObject *mud_message(PyObject *self, PyObject *args) {
+  // the python/C representations of the various variables that message() needs
+  PyObject    *pych = NULL;     CHAR_DATA     *ch = NULL;
+  PyObject  *pyvict = NULL;     CHAR_DATA   *vict = NULL;
+  PyObject   *pyobj = NULL;     OBJ_DATA     *obj = NULL;
+  PyObject  *pyvobj = NULL;     OBJ_DATA    *vobj = NULL;
+  char     *pyrange = NULL;     bitvector_t range = 0;
+  char        *mssg = NULL;
+  int    hide_nosee = 0;
+
+  // parse all of the arguments
+  if(!PyArg_ParseTuple(args, "OOOObss", &pych, &pyvict, &pyobj, &pyvobj,
+		       &hide_nosee, &pyrange, &mssg)) {
+    PyErr_Format(PyExc_TypeError,"Invalid arguments supplied to mud.message()");
+    return NULL;
+  }
+
+  // convert the character
+  if(pych != Py_None) {
+    if(!PyChar_Check(pych) || (ch = PyChar_AsChar(pych)) == NULL) {
+      PyErr_Format(PyExc_TypeError, 
+		   "First argument must be an existent character or None!");
+      return NULL;
+    }
+  }
+
+  // convert the victim
+  if(pyvict != Py_None) {
+    if(!PyChar_Check(pyvict) || (vict = PyChar_AsChar(pyvict)) == NULL) {
+      PyErr_Format(PyExc_TypeError, 
+		   "Second argument must be an existent character or None!");
+      return NULL;
+    }
+  }
+
+  // convert the object
+  if(pyobj != Py_None) {
+    if(!PyObj_Check(pyobj) || (obj = PyObj_AsObj(pyobj)) == NULL) {
+      PyErr_Format(PyExc_TypeError, 
+		   "Third argument must be an existent object or None!");
+      return NULL;
+    }
+  }
+
+  // convert the target object
+  if(pyvobj != Py_None) {
+    if(!PyObj_Check(pyvobj) || (vobj = PyObj_AsObj(pyvobj)) == NULL) {
+      PyErr_Format(PyExc_TypeError, 
+		   "Fourth argument must be an existent object or None!");
+      return NULL;
+    }
+  }
+
+  // check all of our keywords: char, vict, room
+  if(is_keyword(pyrange, "to_char", FALSE))
+    SET_BIT(range, TO_CHAR);
+  if(is_keyword(pyrange, "to_vict", FALSE))
+    SET_BIT(range, TO_VICT);
+  if(is_keyword(pyrange, "to_room", FALSE))
+    SET_BIT(range, TO_ROOM);
+
+  // finally, send out the message
+  message(ch, vict, obj, vobj, hide_nosee, range, mssg);
+  return Py_BuildValue("i", 1);
+}
+
+
+//
+// extracts an mob or object from the game
+PyObject *mud_extract(PyObject *self, PyObject *args) {
+  PyObject *thing = NULL;
+
+  // parse the value
+  if (!PyArg_ParseTuple(args, "O", &thing)) {
+    PyErr_Format(PyExc_TypeError, 
+		 "extract must be provided with an object or mob to extract!.");
+    return NULL;
+  }
+
+  // check its type
+  if(PyChar_Check(thing)) {
+    CHAR_DATA *ch = PyChar_AsChar(thing);
+    if(ch != NULL)
+      extract_mobile(ch);
+    else {
+      PyErr_Format(PyExc_StandardError,
+		   "Tried to extract nonexistent character!");
+      return NULL;
+    }
+  }
+  else if(PyObj_Check(thing)) {
+    OBJ_DATA *obj = PyObj_AsObj(thing);
+    if(obj != NULL)
+      extract_obj(obj);
+    else {
+      PyErr_Format(PyExc_StandardError,
+		   "Tried to extract nonexistent object!");
+      return NULL;
+    }
+  }
+  
+  // success
+  return Py_BuildValue("i", 1);
+}
 
 
 //*****************************************************************************
@@ -191,7 +295,7 @@
 // MUD module
 //
 //*****************************************************************************
-static PyMethodDef mud_module_methods[] = {
+PyMethodDef mud_module_methods[] = {
     {"get_global",  mud_get_global, METH_VARARGS,
      "Get the value of a global variable."},
     {"set_global",  mud_set_global, METH_VARARGS,
@@ -200,8 +304,14 @@
      "Erase the value of a global variable."},
     {"add_cmd", mud_add_cmd, METH_VARARGS,
      "Add a new command to the game."},
+    {"message", mud_message, METH_VARARGS,
+     "plugs into the message() function from inform.h" },
     {"format_string", mud_format_string, METH_VARARGS,
      "format a string to be 80 chars wide and indented. Like a desc."},
+    {"extract", mud_extract, METH_VARARGS,
+    "extracts an object or character from the game. This method is dangerous, "
+    "sicne the object may still be needed in whichever function called the "
+    "script that activated this method" },
     {NULL, NULL, 0, NULL}        /* Sentinel */
 };
 
diff -ruN ../nakedmudv2.4/src/scripts/pyobj.c src/scripts/pyobj.c
--- ../nakedmudv2.4/src/scripts/pyobj.c	Sat Jun  4 23:40:29 2005
+++ src/scripts/pyobj.c	Sat Jun 18 15:31:20 2005
@@ -186,6 +186,32 @@
   return Py_BuildValue("O", list);
 }
 
+PyObject *PyObj_getcarrier(PyObj *self, void *closure) {
+  OBJ_DATA *obj = PyObj_AsObj((PyObject *)self);
+  if(obj == NULL)
+    return NULL;
+  if(objGetCarrier(obj) == NULL)
+    return Py_None;
+  return Py_BuildValue("O", newPyChar(objGetCarrier(obj)));
+}
+
+PyObject *PyObj_getroom(PyObj *self, void *closure) {
+  OBJ_DATA *obj = PyObj_AsObj((PyObject *)self);
+  if(obj == NULL)
+    return NULL;
+  if(objGetRoom(obj) == NULL)
+    return Py_None;
+  return Py_BuildValue("O", newPyRoom(objGetRoom(obj)));
+}
+
+PyObject *PyObj_getcontainer(PyObj *self, void *closure) {
+  OBJ_DATA *obj = PyObj_AsObj((PyObject *)self);
+  if(obj == NULL)
+    return NULL;
+  if(objGetContainer(obj) == NULL)
+    return Py_None;
+  return Py_BuildValue("O", newPyObj(objGetContainer(obj)));
+}
 
 //
 // Standard check to make sure the object exists when
@@ -329,7 +355,7 @@
 int PyObj_setweight(PyObj *self, PyObject *value, void *closure) {
   if (value == NULL) {
     PyErr_Format(PyExc_TypeError, "Cannot delete object's weight");
-    return 0;
+    return -1;
   }
 
   if (!PyFloat_Check(value)) {
@@ -344,6 +370,111 @@
   return 0;
 }
 
+int PyObj_setcarrier(PyObj *self, PyObject *value, void *closure) {
+  if (value == NULL) {
+    PyErr_Format(PyExc_TypeError, "Cannot delete object's carrier");
+    return -1;
+  }
+
+  if (!PyChar_Check(value)) {
+    PyErr_Format(PyExc_TypeError, 
+                    "Carrier must be a character!");
+    return -1;
+  }
+
+  OBJ_DATA *obj;
+  PYOBJ_CHECK_OBJ_EXISTS(self->uid, obj);
+  CHAR_DATA *carrier = PyChar_AsChar(value);
+  // remove us from whatever we're currently in
+  if(objGetRoom(obj))
+    obj_from_room(obj);
+  if(objGetCarrier(obj))
+    obj_from_char(obj);
+  if(objGetContainer(obj))
+    obj_from_obj(obj);
+  if(objGetWearer(obj)) {
+    // weird... we couldn't unequip the item from the current wearer
+    if(!try_unequip(objGetWearer(obj), obj)) {
+      PyErr_Format(PyExc_StandardError, "Could not unequip previous wearer.");
+      return -1;
+    }
+  }
+
+  // give the obj to the character
+  obj_to_char(obj, carrier);
+  return 0;
+}
+
+int PyObj_setroom(PyObj *self, PyObject *value, void *closure) {
+  if (value == NULL) {
+    PyErr_Format(PyExc_TypeError, "Cannot delete object's room");
+    return -1;
+  }
+
+  if (!PyRoom_Check(value)) {
+    PyErr_Format(PyExc_TypeError, 
+                    "Room must be a room!");
+    return -1;
+  }
+
+  OBJ_DATA *obj;
+  PYOBJ_CHECK_OBJ_EXISTS(self->uid, obj);
+  ROOM_DATA *room = PyRoom_AsRoom(value);
+  // remove us from whatever we're currently in
+  if(objGetRoom(obj))
+    obj_from_room(obj);
+  if(objGetCarrier(obj))
+    obj_from_char(obj);
+  if(objGetContainer(obj))
+    obj_from_obj(obj);
+  if(objGetWearer(obj)) {
+    // weird... we couldn't unequip the item from the current wearer
+    if(!try_unequip(objGetWearer(obj), obj)) {
+      PyErr_Format(PyExc_StandardError, "Could not unequip wearer.");
+      return -1;
+    }
+  }
+
+  // give the obj to the character
+  obj_to_room(obj, room);
+  return 0;
+}
+
+int PyObj_setcontainer(PyObj *self, PyObject *value, void *closure) {
+  if (value == NULL) {
+    PyErr_Format(PyExc_TypeError, "Cannot delete object's container");
+    return -1;
+  }
+
+  if (!PyObj_Check(value)) {
+    PyErr_Format(PyExc_TypeError, 
+                    "Container must be an object!");
+    return -1;
+  }
+
+  OBJ_DATA *obj, *cont;
+  PYOBJ_CHECK_OBJ_EXISTS(self->uid, obj);
+  PYOBJ_CHECK_OBJ_EXISTS(((PyObj *)value)->uid, cont);
+  // remove us from whatever we're currently in
+  if(objGetRoom(obj))
+    obj_from_room(obj);
+  if(objGetCarrier(obj))
+    obj_from_char(obj);
+  if(objGetContainer(obj))
+    obj_from_obj(obj);
+  if(objGetWearer(obj)) {
+    // weird... we couldn't unequip the item from the current wearer
+    if(!try_unequip(objGetWearer(obj), obj)) {
+      PyErr_Format(PyExc_StandardError, "Could not unequip wearer.");
+      return -1;
+    }
+  }
+
+  // give the obj to the character
+  obj_to_obj(obj, cont);
+  return 0;
+}
+
 
 
 //*****************************************************************************
@@ -367,7 +498,7 @@
     return Py_BuildValue("i", 1);
   }
   else {
-    PyErr_Format(PyExc_TypeError, 
+    PyErr_Format(PyExc_StandardError, 
 		 "Tried to attach script to nonexistant obj, %d, or script %d "
 		 "does not exit.", self->uid, (int)vnum);
     return NULL;
@@ -393,7 +524,7 @@
     return Py_BuildValue("i", 1);
   }
   else {
-    PyErr_Format(PyExc_TypeError, 
+    PyErr_Format(PyExc_StandardError, 
 		 "Tried to detach script from nonexistant obj, %d, or script "
 		 "%d does not exit.", self->uid, (int)vnum);
     return NULL;
@@ -453,7 +584,7 @@
 // the obj module
 //*****************************************************************************
 PyObject *PyObj_load_obj(PyObject *self, PyObject *args) {
-  int obj_vnum = NOBODY;
+  int vnum     = NOBODY;
   PyObject *in = NULL;
 
   ROOM_DATA *room = NULL; // are we loading to a room?
@@ -461,14 +592,14 @@
   CHAR_DATA *ch   = NULL; // are we loading to a character?
   char *equip_to  = NULL; // are we trying to equip the character?
 
-  if (!PyArg_ParseTuple(args, "iO|s", &obj_vnum, &in, &equip_to)) {
+  if (!PyArg_ParseTuple(args, "iO|s", &vnum, &in, &equip_to)) {
     PyErr_Format(PyExc_TypeError, 
 		 "Load obj failed - it needs a vnum and destination.");
     return NULL;
   }
 
   // check the obj
-  OBJ_DATA *obj_proto = worldGetObj(gameworld, obj_vnum);
+  OBJ_DATA *obj_proto = worldGetObj(gameworld, vnum);
   if(obj_proto == NULL) {
     PyErr_Format(PyExc_TypeError, 
                     "Load obj failed: object number does not exist.");
@@ -720,6 +851,15 @@
 		       "the virtual number for the object.");
     PyObj_addGetSetter("bits", PyObj_getbits, PyObj_setbits,
 		       "the object's basic bitvector.");
+    PyObj_addGetSetter("carrier", PyObj_getcarrier, PyObj_setcarrier,
+		       "the person carrying the object");
+    PyObj_addGetSetter("room", PyObj_getroom, PyObj_setroom,
+		       "The room this object is in. "
+		       "None if on a character or in another object");
+    PyObj_addGetSetter("container", PyObj_getcontainer, PyObj_setcontainer,
+		       "The container this object is in. "
+		       "None if on a character or in a room");
+
 
     // methods
     PyObj_addMethod("attach", PyObj_attach, METH_VARARGS,
@@ -744,8 +884,9 @@
       return;
 
     // add the obj class to the obj module
+    PyTypeObject *type = &PyObj_Type;
     Py_INCREF(&PyObj_Type);
-    PyModule_AddObject(m, "Obj", (PyObject *)&PyObj_Type);
+    PyModule_AddObject(m, "Obj", (PyObject *)type);
 }
 
 
diff -ruN ../nakedmudv2.4/src/scripts/pyroom.c src/scripts/pyroom.c
--- ../nakedmudv2.4/src/scripts/pyroom.c	Sat Jun  4 23:40:29 2005
+++ src/scripts/pyroom.c	Sat Jun 18 15:29:15 2005
@@ -40,7 +40,7 @@
 
 typedef struct {
   PyObject_HEAD
-  room_vnum vnum;
+  int vnum;
 } PyRoom;
 
 
@@ -481,7 +481,7 @@
     return Py_BuildValue("i", 1);
   }
   else {
-    PyErr_Format(PyExc_TypeError, 
+    PyErr_Format(PyExc_StandardError, 
 		 "Tried to attach script to nonexistant room, %d, or script %d "
 		 "does not exit.", self->vnum, (int)vnum);
     return NULL;
@@ -507,7 +507,7 @@
     return Py_BuildValue("i", 1);
   }
   else {
-    PyErr_Format(PyExc_TypeError, 
+    PyErr_Format(PyExc_StandardError, 
 		 "Tried to detach script from nonexistant room, %d, or script "
 		 "%d does not exit.", self->vnum, (int)vnum);
     return NULL;
@@ -653,7 +653,8 @@
       return;
 
     // add the Room class to the room module
-    PyModule_AddObject(module, "Room", (PyObject *)&PyRoom_Type);
+    PyTypeObject *type = &PyRoom_Type;
+    PyModule_AddObject(module, "Room", (PyObject *)type);
     Py_INCREF(&PyRoom_Type);
 }
 
